USE stackoverflow17_03;

# load java answers exported from BigQuery

DROP TABLE IF EXISTS java_answers;
CREATE TABLE java_answers (
    post_id INT NOT NULL
);
CREATE INDEX java_answers_index_1 ON java_answers(post_id);

LOAD DATA LOCAL INFILE "C:\\ProgramData\\MySQL\\MySQL Server 5.7\\Uploads\\java_answers_export.csv"
  INTO TABLE java_answers
  FIELDS TERMINATED BY ','
    LINES TERMINATED BY '\n'
    IGNORE 1 LINES;

    
# get data from posthistory and export to CSV

DROP TABLE IF EXISTS java_answers_text;
CREATE TABLE java_answers_text (
    post_id INT NOT NULL,
    post_history_id INT NOT NULL ,
    creation_date DATETIME,
    last_edit_date DATETIME,
    text TEXT,
    body TEXT
);
CREATE INDEX java_answers_text_index_1 ON java_answers_text(post_id);
CREATE INDEX java_answers_text_index_2 ON java_answers_text(post_history_id);

INSERT INTO java_answers_text(post_id, post_history_id, creation_date, last_edit_date, text, body)
SELECT
	PostId,
	PostHistoryId,
	CreationDate,
	mostRecent2.LastEditDate AS LastEditDate,
	Text,
	Body
FROM (
	SELECT
	  mostRecent.PostId AS PostId,
	  PostHistoryId,
	  CreationDate AS LastEditDate,
	  Text
	FROM (
	  SELECT
		PostId,
		MAX(Id) AS PostHistoryId
	  FROM
		stackoverflow17_03.posthistory ph1
	  INNER JOIN
		stackoverflow17_03.java_answers ja
	  ON
		ph1.PostId = ja.post_id
	  WHERE
		(PostHistoryTypeId = 2 # "initial body"
		OR PostHistoryTypeId = 5 # "edit body"
		OR PostHistoryTypeId = 8) # "rollback body"
		AND LENGTH(Text) > 0
	  GROUP BY
		PostId
	) AS mostRecent
	INNER JOIN stackoverflow17_03.posthistory ph2
	ON ph2.Id = mostRecent.PostHistoryId
) as mostRecent2
INNER JOIN stackoverflow17_03.posts p
ON mostRecent2.PostId = p.Id;

# https://cloud.google.com/sql/docs/mysql/import-export/
SET NAMES utf8;
SELECT *
FROM java_answers_text
INTO OUTFILE "C:\\ProgramData\\MySQL\\MySQL Server 5.7\\Uploads\\java_answers_text.csv"
CHARACTER SET 'utf8'
FIELDS TERMINATED BY ','
OPTIONALLY ENCLOSED BY '\"'
ESCAPED BY '\"'
LINES TERMINATED BY '\n';
