--- Status: 27.03.2017

--- disable legacy SQL

--------------------------------------------------------
--- QUESTION POSTS
--------------------------------------------------------

--- Get questions tagged with "java" or "android"
SELECT
  id as post_id,
  REGEXP_CONTAINS(tags, r'(?:^|.+\|)(java)(?:\||$)') as java_tag,
  REGEXP_CONTAINS(tags, r'(?:^|.+\|)(android)(?:\||$)') as android_tag,
  creation_date,
  score
FROM `bigquery-public-data.stackoverflow.posts_questions`
WHERE REGEXP_CONTAINS(tags, r'(?:^|.+\|)(java|android)(?:\||$)');

=> so_java.questions


--- Number of question
SELECT COUNT(DISTINCT id)
FROM `so-snippets.so_java.questions`;
=> 2,009,378

--- Get most recent version of java questions from post_history.
--- Advantages: * Markdown without HTML character escaping like in posts_questions.
---             * Differentiation between code blocks and inline code highlighting (code spans, see http://stackoverflow.com/editing-help#code).
SELECT ph.post_id as post_id, MAX(ph.id) as post_history_id 
FROM
  `bigquery-public-data.stackoverflow.post_history` ph
  INNER JOIN `so-snippets.so_java.questions` jq
  ON ph.post_id = jq.id
WHERE
  (post_history_type_id = 2 --- "initial body"
  OR post_history_type_id = 5 --- "edit body"
  OR post_history_type_id = 8) --- "rollback body"
  AND LENGTH(text) > 0
GROUP BY post_id;

=> so_java.questions_most_recent_post


SELECT jq.post_id as post_id, post_history_id, creation_date, text
FROM
  `bigquery-public-data.stackoverflow.post_history` ph
  INNER JOIN `so-snippets.so_java.questions_most_recent_post` jq
  ON ph.id = jq.post_history_id;
  
=> gh_java.questions_most_recent


--- Compare number of extracted post_ids with table post_questions and check whether only one row per post_id exists.
SELECT COUNT(*)
FROM `so-snippets.so_java.questions_most_recent`;
=> 2,009,376

SELECT COUNT(DISTINCT post_id)
FROM `so-snippets.so_java.questions_most_recent`;
=> 2,009,376

SELECT COUNT(DISTINCT id)
FROM `so-snippets.so_java.questions`;
=> 2,009,378
