--- Status: 23.03.2017

--- disable legacy SQL

--- Get GH repos that are no forks and not deleted
SELECT
  repos.repo_id as repo_id,
  repos.repo_name as repo_name,
  repos.repo_language as repo_language,
  count(w.user_id) as watcher_count
FROM 
  (SELECT
    p.id as repo_id,
    CONCAT(u.login, "/", p.name) as repo_name,
    LOWER(p.language) as repo_language
  FROM `ghtorrent-bq.ght_2017_01_19.projects` p
  JOIN `ghtorrent-bq.ght_2017_01_19.users` u
  ON u.id=p.owner_id
  WHERE
    p.forked_from is null --- not a fork
    AND p.deleted = false --- not deleted
) as repos
LEFT JOIN `ghtorrent-bq.ght_2017_01_19.watchers` w
ON repos.repo_id = w.repo_id
GROUP BY repo_id, repo_name, repo_language;

=> gh.repos


--- restrict files to selected github projects
SELECT
  f.id as id,
  f.repo_name as repo_name,
  f.path as path
FROM `bigquery-public-data.github_repos.files` AS f
JOIN `so-snippets.gh.repos` r
ON f.repo_name = r.repo_name;

=> gh.files


--- get most common repo languages
SELECT language, COUNT(id) as project_count
FROM `ghtorrent-bq.ght_2017_01_19.projects`
WHERE deleted = FALSE AND forked_from IS NULL
GROUP BY language
ORDER BY project_count DESC
LIMIT 100;

=> gh_repo_languages_top100.csv