--- Status: 28.03.2017

--- disable legacy SQL

--------------------------------------------------------
--- EXTRACT LINKS FROM SO ANSWERS
--------------------------------------------------------

--- extract links from HTML a elements
SELECT
  post_id,
  links
FROM (
  SELECT
    post_id,
    REGEXP_EXTRACT_ALL(body, r'<a[^>]+href\s*=\s*(?:\"|\')([\s\S]+?)(?:\"|\')') as links
  FROM
    `so-snippets.so_java.answers_text`
)
WHERE
  ARRAY_LENGTH(links)>0;

=> so_java.answers_text_links


--- extract SO links from links
SELECT
  post_id,
  CASE
    WHEN REGEXP_CONTAINS(LOWER(link), r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/a/", REGEXP_EXTRACT(LOWER(link), r'https?:\/\/stackoverflow\.com\/a\/([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(link), r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/q/", REGEXP_EXTRACT(LOWER(link), r'https?:\/\/stackoverflow\.com\/q\/([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(link), r'https?:\/\/stackoverflow\.com\/questions\/[\d]+\/[^\s\/\#]+(?:\/|\#)([\d]+)')
    THEN CONCAT("http://stackoverflow.com/a/", REGEXP_EXTRACT(LOWER(link), r'https?:\/\/stackoverflow\.com\/questions\/[\d]+\/[^\s\/\#]+(?:\/|\#)([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(link), r'(https?:\/\/stackoverflow\.com\/questions\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/q/", REGEXP_EXTRACT(LOWER(link), r'https?:\/\/stackoverflow\.com\/questions\/([\d]+)'))
    ELSE link
  END as so_link
FROM
  `so-snippets.so_java.answers_text_links` l
CROSS JOIN
  UNNEST(l.links) as link
WHERE
  REGEXP_CONTAINS(LOWER(link), r'(https?://stackoverflow\.com/[^\s)\.\"]*)');

=> so_java.answers_text_links_so

SELECT COUNT(*)
FROM `so-snippets.so_java.answers_text_links_so`;

=> 204,568


--- focus on links to answers and questions in the following
SELECT
	*
FROM
	`so-snippets.so_java.answers_text_links_so`
WHERE
  REGEXP_CONTAINS(LOWER(so_link), r'(https?:\/\/stackoverflow\.com\/(?:a|q)\/[\d]+)');

=> so_java.answers_text_links_so_aq

SELECT COUNT(*)
FROM `so-snippets.so_java.answers_text_links_so_aq`;

=> 195,981


--- extract other SO links
SELECT
	*
FROM
	`so-snippets.so_java.answers_text_links_so`
WHERE
  NOT REGEXP_CONTAINS(LOWER(so_link), r'(https?:\/\/stackoverflow\.com\/(?:a|q)\/[\d]+)');

=> so_java.answers_text_links_so_other

SELECT COUNT(*)
FROM `so-snippets.so_java.answers_text_links_so_other`;

=> 8,587


--- extract links to external resources
SELECT
	post_id,
	link
FROM
	`so-snippets.so_java.answers_text_links` l
CROSS JOIN
	UNNEST(l.links) as link
WHERE
	NOT REGEXP_CONTAINS(link, r'(?i:https?://stackoverflow\.com/[^\s)\.\"]*)');

=> so_java.answers_text_links_not_so

SELECT COUNT(*)
FROM `so-snippets.so_java.answers_text_links_not_so`;

=> 1,352,841


--- links to SO in Java files
SELECT
  file_id,
  CASE
    WHEN REGEXP_CONTAINS(LOWER(url), r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/a/", REGEXP_EXTRACT(LOWER(url), r'https?:\/\/stackoverflow\.com\/a\/([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(url), r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/q/", REGEXP_EXTRACT(LOWER(url), r'https?:\/\/stackoverflow\.com\/q\/([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(url), r'https?:\/\/stackoverflow\.com\/questions\/[\d]+\/[^\s\/\#]+(?:\/|\#)([\d]+)')
    THEN CONCAT("http://stackoverflow.com/a/", REGEXP_EXTRACT(LOWER(url), r'https?:\/\/stackoverflow\.com\/questions\/[\d]+\/[^\s\/\#]+(?:\/|\#)([\d]+)'))
    WHEN REGEXP_CONTAINS(LOWER(url), r'(https?:\/\/stackoverflow\.com\/questions\/[\d]+)')
    THEN CONCAT("http://stackoverflow.com/q/", REGEXP_EXTRACT(LOWER(url), r'https?:\/\/stackoverflow\.com\/questions\/([\d]+)'))
    ELSE url
  END as so_link,
  line
FROM (
  SELECT
    file_id,
    REGEXP_REPLACE(
      REGEXP_EXTRACT(LOWER(line), r'(https?://stackoverflow\.com/[^\s)\.\"]*)'),
      r'(^https)',
      'http'
    ) as url,
    line
  FROM (
    SELECT file_id, line
    FROM (
      SELECT id as file_id, SPLIT(content, "\n") as lines
      FROM `so-snippets.gh_java.files_content`
      GROUP BY id, content
    )
    CROSS JOIN UNNEST(lines) as line
  )
  WHERE
    REGEXP_CONTAINS(LOWER(line), r'(https?://stackoverflow\.com/[^\s)\.\"]*)')
);

=> gh_java.files_content_links_so


SELECT *
FROM `so-snippets.gh_java.files_content_links_so`
WHERE REGEXP_CONTAINS(so_link, r'(https?:\/\/stackoverflow\.com\/(?:a|q)\/[\d]+)');

=> gh_java.files_content_links_so_aq


--- get filtered repos with SO reference
SELECT
  COUNT(DISTINCT repo_name)
FROM (
  SELECT
    file_id,
    repo_name
  FROM `so-snippets.gh_java.files_content_links_so_aq` files_links
  INNER JOIN `so-snippets.gh.files` files
  ON files_links.file_id = files.id
) as files2
INNER JOIN `so-snippets.gh_java.files_content_filtered` files_filtered
ON files2.file_id = files_filtered.id;

=> 7,320 (7,320/72,117*100 = 10.15%)










