--- Status: 28.03.2017

--- disable legacy SQL

--------------------------------------------------------
--- CLONE SEARCH
--------------------------------------------------------

--- find snippets in files (sample 1 of 8)

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_1` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_1_1
--- 215,233 * 7,282 = 1,567,326,706
--- Maximum Billing Tier: 4
--- 248.6s seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_1` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_1_2
--- 215,233 * 7,423 = 1,597,674,559
--- Maximum Billing Tier: 4
--- 258.0 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_1` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_1_3
--- 215,233 * 7,346 = 1,581,101,618
--- Maximum Billing Tier: 4
--- 214.2 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_1` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_1_4
--- 215,233 * 7,319 = 1,575,290,327
--- Maximum Billing Tier: 4
--- 208.5 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_1_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_1_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_1_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_1_4`;

=> clones_java.files_matches_sample_1
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_1`;
=> 1,254 

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_1`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,254
 

--- find snippets in files (sample 2 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_2` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_2_1
--- Maximum Billing Tier: 4
--- 268.7 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_2` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_2_2
--- Maximum Billing Tier: 4
--- 331.8 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_2` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_2_3
--- Maximum Billing Tier: 4
--- 287.8 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_2` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_2_4
--- Maximum Billing Tier: 4
--- 275.5 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_2_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_2_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_2_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_2_4`;

=> clones_java.files_matches_sample_2
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_2`;
=> 1,400

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_2`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,400


--- find snippets in files (sample 3 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_3` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_3_1
--- Maximum Billing Tier: 4
--- 258.6 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_3` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_3_2
--- Maximum Billing Tier: 4
--- 211.7 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_3` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_3_3
--- Maximum Billing Tier: 4
--- 321.5 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_3` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_3_4
--- Maximum Billing Tier: 4
--- 253.0 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_3_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_3_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_3_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_3_4`;

=> clones_java.files_matches_sample_3
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_3`;
=> 1,304

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_3`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,304


--- find snippets in files (sample 4 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_4` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_4_1
--- Maximum Billing Tier: 4
--- 210.2 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_4` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_4_2
--- Maximum Billing Tier: 4
--- 219.2 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_4` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_4_3
--- Maximum Billing Tier: 4
--- 254.1 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_4` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_4_4
--- Maximum Billing Tier: 4
--- 423.1 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_4_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_4_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_4_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_4_4`;

=> clones_java.files_matches_sample_4
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_4`;
=> 1,244

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_4`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,244


--- find snippets in files (sample 5 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_5` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_5_1
--- Maximum Billing Tier: 4
--- 276.7 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_5` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_5_2
--- Maximum Billing Tier: 4
--- 237.5 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_5` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_5_3
--- Maximum Billing Tier: 4
--- 288.7 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_5` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_5_4
--- Maximum Billing Tier: 4
--- 273.1 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_5_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_5_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_5_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_5_4`;

=> clones_java.files_matches_sample_5
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_5`;
=> 1,245

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_5`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,245


--- find snippets in files (sample 6 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_6` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_6_1
--- Maximum Billing Tier: 4
--- 271.1 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_6` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_6_2
--- Maximum Billing Tier: 4
--- 343.9 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_6` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_6_3
--- Maximum Billing Tier: 4
--- 332.1 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_6` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_6_4
--- Maximum Billing Tier: 4
--- 236.9 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_6_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_6_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_6_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_6_4`;

=> clones_java.files_matches_sample_6
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_6`;
=> 1,244

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_6`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,244


--- find snippets in files (sample 7 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_7` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_7_1
--- Maximum Billing Tier: 4
--- 331.8 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_7` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_7_2
--- Maximum Billing Tier: 4
--- 227.5 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_7` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_7_3
--- Maximum Billing Tier: 4
--- 243.5 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_7` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_7_4
--- Maximum Billing Tier: 4
--- 269.6 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_7_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_7_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_7_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_7_4`;

=> clones_java.files_matches_sample_7
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_7`;
=>  1,348

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_7`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,348


--- find snippets in files (sample 8 of 8)
 
SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_8` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_1` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_8_1
--- Maximum Billing Tier: 4
--- 356.8 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_8` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_2` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_8_2
--- Maximum Billing Tier: 4
--- 261.0 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_8` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_3` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_8_3
--- Maximum Billing Tier: 4
--- 273.6 seconds

SELECT
  files.id as file_id,
  snippets.code_block_hash as code_block_hash,
  STRPOS(files.content, snippets.code_block) as match_pos
FROM
  `so-snippets.gh_java.files_sample_8` AS files
INNER JOIN
  `so-snippets.so_java.answers_sample_4` AS snippets
ON
  STRPOS(files.content, snippets.code_block) <> 0;

=> clones_java.files_matches_sample_8_4
--- Maximum Billing Tier: 4
--- 307.2 seconds

--- merge matches for all answer samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_8_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_8_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_8_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_8_4`;

=> clones_java.files_matches_sample_8
--- then delete the four above samples 

--- check sample
SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_sample_8`;
=> 1,319

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash, match_pos
  FROM `so-snippets.clones_java.files_matches_sample_8`
  GROUP BY file_id, code_block_hash, match_pos
);
=> 1,319


--- merge matches for all file samples
SELECT *
FROM
`so-snippets.clones_java.files_matches_sample_1`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_2`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_3`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_4`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_5`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_6`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_7`
UNION ALL
SELECT * FROM
`so-snippets.clones_java.files_matches_sample_8`;

=> clones_java.files_matches


--- create one table with all data about matches
WITH
  file_data AS (
    SELECT
      file_id,
      repo_name,
      path,
      CONCAT("https://github.com/", repo_name, "/blob/master/", path) as gh_link,
      code_block_hash,
      match_pos
    FROM
      `so-snippets.gh_java.files_content` f
    INNER JOIN
      `so-snippets.clones_java.files_matches` m
    ON
      f.id = m.file_id
  ),
  answer_data_1 AS (
    SELECT
      post_id,
      CONCAT("http://stackoverflow.com/a/", CAST(post_id AS STRING)) as so_link,
      m.code_block_hash as code_block_hash,
      a.code_block as code_block
    FROM
      `so-snippets.so_java.answers_text_code_blocks` a --- this includes also posts that were previously filtered out, but had the same code block as an included post
    INNER JOIN
      `so-snippets.clones_java.files_matches` m
    ON
      a.code_block_hash = m.code_block_hash
  ),
  answer_data_2 AS (
    SELECT
      post_id,
      post_history_id,
      creation_date,
      last_edit_date
    FROM
      `so-snippets.so_java.answers_text`
  ),
  parent_ids AS (
    SELECT
      post_id,
      parent_id
    FROM
      `so-snippets.so_java.answers`
  )
SELECT
  file_id,
  repo_name,
  path,
  gh_link,
  match_pos,
  post_id,
  parent_id,
  post_history_id,
  so_link,
  creation_date,
  CAST(last_edit_date AS TIMESTAMP) as last_edit_date,
  answer_data.code_block_hash as code_block_hash,
  code_block
FROM file_data
INNER JOIN (
  SELECT
    answer_data_1_2.post_id as post_id,
    parent_id,
    post_history_id,
    answer_data_1_2.creation_date as creation_date,
    last_edit_date,
    so_link,
    code_block_hash,
    code_block  
  FROM (
    SELECT
      answer_data_1.post_id as post_id,
      post_history_id,
      creation_date,
      last_edit_date,
      so_link,
      code_block_hash,
      code_block
    FROM
      answer_data_1
    INNER JOIN
      answer_data_2
    ON
      answer_data_1.post_id = answer_data_2.post_id
    ) as answer_data_1_2
    INNER JOIN
      parent_ids
    ON
      answer_data_1_2.post_id = parent_ids.post_id
) as answer_data
ON
  file_data.code_block_hash = answer_data.code_block_hash
GROUP BY
  file_id, repo_name, path, gh_link, match_pos,
  post_id, parent_id, post_history_id, so_link,
  creation_date, last_edit_date, code_block_hash,
  code_block;

=> clones_java.files_matches_complete_data


--- get array representation of matches
SELECT
  code_block_hash,
  ARRAY_AGG(DISTINCT m.post_id) as post_ids,
  ARRAY_AGG(DISTINCT a.parent_id) as parent_ids,
  ARRAY_AGG(DISTINCT so_link) as so_links,
  ARRAY_AGG(DISTINCT CONCAT("https://stackoverflow.com/q/", CAST(a.parent_id AS STRING))) as parent_so_links,
  code_block
FROM
  `so-snippets.clones_java.files_matches_complete_data` m
INNER JOIN
  `so-snippets.so_java.answers` a
ON
  m.post_id = a.post_id
GROUP BY
  code_block_hash, code_block;

=> clones_java.files_matches_complete_data_arrays


--- check difference between creation date and last edit date
SELECT *
FROM `so-snippets.clones_java.files_matches_complete_data`
WHERE DATE_DIFF(CAST(last_edit_date AS DATE), CAST(creation_date AS DATE), DAY) > 1;


--- analysis of matches

SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_complete_data`;

=> 33,467

SELECT COUNT(*)
FROM `so-snippets.clones_java.files_matches_complete_data_arrays`;

=> 1,272

SELECT COUNT(DISTINCT so_link)
FROM `so-snippets.clones_java.files_matches_complete_data`;
=> 1,784

SELECT COUNT(DISTINCT code_block_hash)
FROM `so-snippets.clones_java.files_matches_complete_data`;
=> 1,272

SELECT COUNT(DISTINCT file_id)
FROM `so-snippets.clones_java.files_matches_complete_data`;

=> 6,579

SELECT COUNT(DISTINCT repo_name)
FROM `so-snippets.clones_java.files_matches_complete_data`;

=> 5,937

SELECT COUNT(DISTINCT gh_link)
FROM `so-snippets.clones_java.files_matches_complete_data`;

=> 12,635

SELECT COUNT(*)
FROM (
  SELECT file_id, code_block_hash
  FROM `so-snippets.clones_java.files_matches_complete_data`
  GROUP BY file_id, code_block_hash
);

=> 10,358


