setwd("/Users/sebastian/Sebastian (DS)/Forschung/Projekte/Snippets/esem17")

library(data.table)
matches <- fread("java_files_matches_filtered_norm_filtered_commits_newer.csv", header=TRUE, sep=",", quote="\"", strip.white=TRUE, showProgress=TRUE, encoding="UTF-8", na.strings=c("", "null"))

nrow(matches)
# 908

matches$creation_date <- as.POSIXct(matches$creation_date, tz="UTC")
matches$commit_date <- as.POSIXct(matches$commit_date, tz="UTC")

diff_days <- as.integer(difftime(matches$commit_date, matches$creation_date, units="days"))

boxplot(diff_days/365)

pdf("creation_vs_commit_date.pdf", bg="transparent", width=5, height=2.5)
par(
  mar = c(2.5, 2, 1.5, 2), # subplot margins (bottom, left, top, right)
  #omi = c(0.2, 0.2, 0.2, 0.2)  # outer margins in inches (bottom, left, top, right)
  #mfrow = c(3, 1)
  #pin = (width, height)
  #mfcol # draw in columns
  # increase font size
  cex.main=1.2,
  cex.lab=1.2,
  cex.axis=1.2
)

library(vioplot)
vioplot(diff_days/365,
        col="gray90", pchMed=4, rectCol="white", colMed="black",
        horizontal=TRUE, names=c(""), wex=1.1)
#title("Time diff SO post GH commit (years)")
abline(h=median(diff_days/365), lty=2)

dev.off() 


median(diff_days/365)
# 3.210959

mean(diff_days/365)
# 3.224268

summary(diff_days)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.0   610.8  1172.0  1177.0  1640.0  3039.0 

summary(diff_days/365)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.000   1.673   3.211   3.224   4.495   8.326 
